routes/web.php
<?php

use App\Http\Controllers\LanguageController;

/*
 * Global Routes
 * Routes that are used between both frontend and backend.
 */

// Switch between the included languages
Route::get('lang/{lang}', [LanguageController::class, 'swap']);

/*
 * Frontend Routes
 * Namespaces indicate folder structure
 */
Route::group(['namespace' => 'Frontend', 'as' => 'frontend.'], function () {
    include_route_files(__DIR__.'/frontend/');
});

/*
 * Backend Routes
 * Namespaces indicate folder structure
 */

//CATATAN DODE
// Untuk redirect user sesuai role, bisa diubah di app\Helpers\Global\GeneralHelper
// Route::group(['namespace' => 'Backend', 'prefix' => 'admin', 'as' => 'admin.'], function () {
Route::group(['namespace' => 'Backend', 'prefix' => 'admin', 'as' => 'admin.', 'middleware' => 'admingroupmiddleware'], function () {

// middleware adminadminGroupMiddleware adalah alias dan sebenarnya ada di http/kernel.php

    /*
     * These routes need view-backend permission
     * (good if you want to allow more than one group in the backend,
     * then limit the backend features by different roles or permissions)
     *
     * Note: Administrator has all permissions so you do not have to specify the administrator role everywhere.
     * These routes can not be hit if the password is expired
     */
    include_route_files(__DIR__.'/backend/');
});

// Route::group(['namespace' => 'Innovator', 'prefix' => 'innovator', 'as' => 'innovator.'], function () {
Route::group(['namespace' => 'Innovator', 'prefix' => 'innovator', 'as' => 'innovator.', 'middleware' => 'innovatorgroupmiddleware'], function () {
    /*
     * These routes need view-backend permission
     * (good if you want to allow more than one group in the backend,
     * then limit the backend features by different roles or permissions)
     *
     * Note: Administrator has all permissions so you do not have to specify the administrator role everywhere.
     * These routes can not be hit if the password is expired
     */
    include_route_files(__DIR__.'/innovator/');
});


Route::group(['namespace' => 'Auditor', 'prefix' => 'auditor', 'as' => 'auditor.', 'middleware' => 'auditorgroupmiddleware'], function () {
    /*
     * These routes need view-backend permission
     * (good if you want to allow more than one group in the backend,
     * then limit the backend features by different roles or permissions)
     *
     * Note: Administrator has all permissions so you do not have to specify the administrator role everywhere.
     * These routes can not be hit if the password is expired
     */
    include_route_files(__DIR__.'/auditor/');
});

app/Http/Controllers/Frontend/Blog/BlogController.php
<?php

namespace App\Http\Controllers\Frontend\Blog;

use App\Http\Controllers\Controller;
use App\Repositories\Frontend\Blog\BlogRepository;
use Illuminate\Support\Facades\DB;
use Artesaos\SEOTools\Facades\SEOTools;
use Artesaos\SEOTools\Facades\SEOMeta;
use Artesaos\SEOTools\Facades\OpenGraph;
use Artesaos\SEOTools\Facades\TwitterCard;
use Artesaos\SEOTools\Facades\JsonLd;
use Illuminate\Http\Request;
/**
 * Class HomeController.
 */
class BlogController extends Controller
{
    /**
     * @return \Illuminate\View\View
     */

      protected $blogentry;

    public function __construct(BlogRepository $blogentry)
    {
        //Instance repository UserRepository kedalam property $user
        $this->blogentry = $blogentry;
    }


    public function all()
    {
    	return $this->blogentry->showall();
        // return view('frontend.blogs', ['blogsdata'=>$blogsdata] );
    }   

    public function index()
    {
        //return view('frontend.blogs');
        $alldata = DB::table('blog_entries')->orderBy('id', 'desc')->paginate(3);
        $blogsdata = DB::table('blog_entries')->orderBy('id', 'desc')->paginate(5);
        return view('frontend.blogs', ['blogsdata'=>$blogsdata],['alldata'=>$alldata] );
    }

    public function seoblog($slug)
    {
        $datablog = DB::table('blog_entries')->where('slug',$slug)->first();
        SEOMeta::setTitle($datablog->title);
        SEOMeta::setDescription($datablog->description);
        //SEOMeta::addMeta('article:created_at', $datablog->created_at->toW3CString(), 'property');
        //SEOMeta::addMeta('article:section', $post->category, 'property');
        SEOMeta::addKeyword(['sunat balita', 'sunat dewasa', 'sunat anak', 'sunat khusus', 'rumah sunat bali', 'sunat bali', 'sunatan','khitan']);

        OpenGraph::setDescription($datablog->description);
        OpenGraph::setTitle($datablog->page_title);
        //OpenGraph::setUrl('/blog/{$datablog->id}');
        OpenGraph::addProperty('type', 'article');
        OpenGraph::addProperty('locale', 'pt-br');
        OpenGraph::addProperty('locale:alternate', ['pt-pt', 'en-us']);

        //OpenGraph::addImage($datablog->image->url);
        // OpenGraph::addImage($datablog->image->list('url'));
        //OpenGraph::addImage(['url' => 'http://image.url.com/cover.jpg', 'size' => 300]);
        //OpenGraph::addImage('http://image.url.com/cover.jpg', ['height' => 300, 'width' => 300]);
        
        JsonLd::setTitle($datablog->title);
        JsonLd::setDescription($datablog->description);
        JsonLd::setType('Article');
        //JsonLd::addImage($datablog->image->list('url'));
    }

    public function article($slug)
    {

        $this->seoblog($slug);

    	$blogsdata = $this->blogentry->find($slug);   
        $alldata = DB::table('blog_entries')->orderBy('id', 'desc')->paginate(3);

        return view('frontend.article', ['blogsdata'=>$blogsdata], ['alldata'=>$alldata] );
        
    }
}

app/Http/Controllers/Frontend/ContactController.php
<?php

namespace App\Http\Controllers\Frontend;

use App\Http\Controllers\Controller;
use App\Http\Requests\Frontend\Contact\SendContactRequest;
use App\Mail\Frontend\Contact\SendContact;
use Illuminate\Support\Facades\Mail;

/**
 * Class ContactController.
 */
class ContactController extends Controller
{
    /**
     * @return \Illuminate\View\View
     */
    public function index()
    {
        return view('frontend.contact');
    }

    /**
     * @param SendContactRequest $request
     *
     * @return mixed
     */
    public function send(SendContactRequest $request)
    {
        Mail::send(new SendContact($request));

        return redirect()->back()->withFlashSuccess(__('alerts.frontend.contact.sent'));
    }
}

app/Http/Controllers/Frontend/InovasiController.php
<?php

namespace App\Http\Controllers\Frontend;

use Illuminate\Http\Request;
use App\Models\Innovations\Hki;
use App\Http\Controllers\Controller;
use Illuminate\Support\Facades\File;
use App\Models\Innovations\Innovation;
use Illuminate\Support\Facades\Storage;
use App\Models\Innovations\CovidInovasi;
use App\Models\Innovations\JenisInovasi;
use App\Models\Innovations\VideoInovasi;
use Illuminate\Support\Facades\Response;
use App\Models\Innovations\BentukInovasi;
use App\Models\Innovations\BidangInovasi;
use App\Models\Innovations\ProsesInovasi;
use App\Models\Innovations\SistemInovasi;
use App\Models\Innovations\UrusanInovasi;
use App\Models\Innovations\TahapanInovasi;
use App\Models\Innovations\AnggaranInovasi;
use App\Models\Innovations\InisiatorInovasi;
use App\Models\Innovations\PengalamanInovasi;
use App\Models\Innovations\PenghargaanInovasi;
use App\Models\Kuisioners\Kuisioner;
use App\Models\VerifikasiDokumen;

class InovasiController extends Controller
{
    public function getData()
    {
        if (auth()->check()) {
            if (auth()->user()->hasRole(['administrator'])) {
                //  return 'admin.dashboard';
            }
            if (auth()->user()->hasRole(['innovator'])) {
                $innovator = auth()->user()->innovator()->first();
            }
            if (auth()->user()->hasRole(['auditor'])) {
                // return 'auditor.dashboard';
            }
        }
        $innovatorid = $innovator->id;
        $data = Innovation::whereHas('innovator', function($q) use($innovatorid) {
            $q->where([['innovator_id', $innovatorid],['status','!=', 'deleted']]);
        })->with(['kuisioner','urusaninovasi','penghargaans','pengalamans','hkis','varifikasidokumen'])->get();
        // dd($data);
        return $data;
    }
    public function getallData()
    {
        if (auth()->check()) {
            if (auth()->user()->hasRole(['administrator'])) {
                //  return 'admin.dashboard';
            }
            if (auth()->user()->hasRole(['innovator'])) {
                $innovator = auth()->user()->innovator()->first();
            }
            if (auth()->user()->hasRole(['auditor'])) {
                // return 'auditor.dashboard';
            }
        }
        $innovatorid = $innovator->id;
        $data = Innovation::whereHas('innovator', function($q) use($innovatorid) {
            $q->where([['status','=', 'approve']]);
        })->with(['kuisioner','urusaninovasi','penghargaans','pengalamans','hkis','varifikasidokumen'])->get();
        // dd($data);
        return $data;
    }

    public function getInovasi()
    {
        if (auth()->check()) {
            if (auth()->user()->hasRole(['administrator'])) {
                //  return 'admin.dashboard';
            }
            if (auth()->user()->hasRole(['innovator'])) {
                $innovator = auth()->user()->innovator()->first();
            }
            if (auth()->user()->hasRole(['auditor'])) {
                // return 'auditor.dashboard';
            }
        }
        $innovatorid = $innovator->id;
        $data = Innovation::whereHas('innovator', function($q) use($innovatorid) {
            $q->where([['innovator_id', $innovatorid],['status', 'draft']]);
        })->with(['kuisioner','urusaninovasi','penghargaans','pengalamans','hkis','varifikasidokumen'])->first();

        // $data = Innovation::with('innovator')->where([['innovator_id', $innovatorid->id],['kuisioner_id', 1]])->first();
        // dd($innovation1);
        return $data;
    }

    public function previewInovasi()
    {
        if (auth()->check()) {
            if (auth()->user()->hasRole(['administrator'])) {
                //  return 'admin.dashboard';
            }
            if (auth()->user()->hasRole(['innovator'])) {
                $innovator = auth()->user()->innovator()->first();
            }
            if (auth()->user()->hasRole(['auditor'])) {
                // return 'auditor.dashboard';
            }
        }
        $innovatorid = $innovator->id;
        $data = Innovation::whereHas('innovator', function($q) use($innovatorid) {
            $q->where([['innovator_id', $innovatorid],['status', 'draft']]);
        })->with([
            'urusaninovasi','penghargaans','pengalamans','hkis','jenisinovasi',
            'bidanginovasi','bentukinovasi','sisteminovasi','tahapaninovasi',
            'covidinovasi','inisiatorinovasi','innovator'
        ])->first();

        return $data;
    }

    public function getInnovator()
    {
        if (auth()->check()) {
            if (auth()->user()->hasRole(['administrator'])) {
                //  return 'admin.dashboard';
            }
            if (auth()->user()->hasRole(['innovator'])) {
                $inovator = auth()->user()->innovator()->first();
            }
            if (auth()->user()->hasRole(['auditor'])) {
                // return 'auditor.dashboard';
            }
        }
        // dd($innovation1);
        return $inovator;
    }


    //funtion for get all data inovations (vue js)
    public function getTahapanInovasi()
    {
        $data = TahapanInovasi::where('id', '>', 1)->get();
        return $data;
    }
    public function getInisiatorInovasi(){
        $data = InisiatorInovasi::where('id', '>', 1)->get();
        return $data;
    }
    public function getSistemInovasi(){
        $data = SistemInovasi::where('id', '>', 1)->get();
        return $data;
    }
    public function getBentukInovasi(){
        $data = BentukInovasi::where('id', '>', 1)->get();
        return $data;
    }
    public function getJenisInovasi(){
        $data = JenisInovasi::where('id', '>', 1)->get();
        return $data;
    }
    public function getCovidInovasi(){
        $data = CovidInovasi::where('id', '>', 1)->get();
        return $data;
    }
    public function getBidangInovasi(){
        $data = BidangInovasi::where('id', '>', 1)->get();
        return $data;
    }
    public function getUrusanInovasi(){
        $alldata = UrusanInovasi::where('id', '>', 1)->get(['id','name']);
        // $data =[
        // //     'id' =>  $alldata->id,
        // //     'name' =>  $alldata->name,
        // // ];
        return $alldata;
    }
    public function getAnggaranInovasi(){
        $data = AnggaranInovasi::where('id', '>', 1)->get();
        return $data;
    }
    public function getProsesInovasi(){
        $data = ProsesInovasi::where('id', '>', 1)->get();
        return $data;
    }
    public function getVideoInovasi(){
        $data = VideoInovasi::where('id', '>', 1)->get();
        return $data;
    }

    //function for insert data innovation in the beginning
    public function InsertComments(Request $request)
    {
        $data = $request->all();
        $datacomments = [
            'auditor_id' => $data['auditor_id'],
            'innovation_id' => $data['innovation_id'],
            'data' => $data['data'],
        ];
        $datacoment = VerifikasiDokumen::create($datacomments);
        return $datacoment->id;
    }
    public function UpdateComments(Request $request, $id)
    {
        $data = $request->all();
        $datacomments = [
            'auditor_id' => $data['auditor_id'],
            'innovation_id' => $data['innovation_id'],
            'data' => $data['data'],
        ];
        $datacoment = VerifikasiDokumen::findorFail($id);
        $datacoment->update($datacomments);
        return $datacoment->id;
    }
    public function InsertInnovations(Request $request)
    {
        if (auth()->check()) {
            if (auth()->user()->hasRole(['administrator'])) {
                //  return 'admin.dashboard';
            }
            if (auth()->user()->hasRole(['innovator'])) {
                $innovator = auth()->user()->innovator()->first();
            }
            if (auth()->user()->hasRole(['auditor'])) {
                // return 'auditor.dashboard';
            }
        }
        $innovatorid = $innovator->id;

        $datainnovation = [
            'innovator_id' => $innovatorid,
            'status' => 'draft',
            'checkinovasi' => 0
        ];

        $innovation = Innovation::create($datainnovation);
        $innovation->hkis()->create();
        $kuisioner = Kuisioner::create();
        $innovation->kuisioner()->associate($kuisioner)->save();
        $penghargaan = [
            'nama_penghargaan' => '',
            'pemberi_penghargaan' => '',
            'tahun_penghargaan' => '',
        ];
        $innovation->penghargaans()->create($penghargaan);
        $pengalaman =[
            'nama_pengalaman' => '',
            'penyelenggara' => '',
            'tahun_pengalaman' => '',
            'predikat' => '',
        ];
        $innovation->pengalamans()->create($pengalaman);
        return $innovation->id;
    }
    public function UpdateInnovations(Request $request, $id)
    {
        $data = $request->all();
        // dd($data);
        $data['urusaninovasi'] = json_decode($data['urusaninovasi']);

        $datainnovation = [
            'innovator_id' => $data['innovator_id'],
            'nama_singkat' => $data['nama_singkat'],
            'nama_lengkap' =>  $data['nama_lengkap'],
            'tahapan_inovasi_id' =>  $data['tahapan_inovasi_id'],
            'inisiator_inovasi_id' =>  $data['inisiator_inovasi_id'],
            'sistem_inovasi_id' =>  $data['sistem_inovasi_id'],
            'bentuk_inovasi_id' => $data['bentuk_inovasi_id'],
            'jenis_inovasi_id' => $data['jenis_inovasi_id'],
            'covid_inovasi_id' =>  $data['covid_inovasi_id'],
            'bidang_inovasi_id' =>  $data['bidang_inovasi_id'],
            'waktu_ujicoba' =>  $data['waktu_ujicoba'],
            'waktu_implementasi' =>  $data['waktu_implementasi'],
            'checkinovasi' =>  $data['checkinovasi'],
            'rancang_bangun' => $data['rancang_bangun'],
            'tujuan' => $data['tujuan'],
            'manfaat' => $data['manfaat'],

app/Http/Controllers/Frontend/User/AccountController.php
<?php

namespace App\Http\Controllers\Frontend\User;

use App\Http\Controllers\Controller;

/**
 * Class AccountController.
 */
class AccountController extends Controller
{
    /**
     * @return \Illuminate\Contracts\View\Factory|\Illuminate\View\View
     */
    public function index()
    {
        return view('frontend.user.account');
    }
}

app/Http/Controllers/Frontend/User/DashboardController.php
<?php

namespace App\Http\Controllers\Frontend\User;

use App\Http\Controllers\Controller;

/**
 * Class DashboardController.
 */
class DashboardController extends Controller
{
    /**
     * @return \Illuminate\Contracts\View\Factory|\Illuminate\View\View
     */
    public function index()
    {
        return view('frontend.user.dashboard');
    }
}

resources/views/frontend/includes1/footer.blade.php
<footer class="footer d-flex flex-column flex-md-row align-items-center justify-content-between">
	<p class="text-muted text-center text-md-left">
		 Copyright © 2020 <a href="https://www.nobleui.com" target="_blank">NobleUI</a>. All rights reserved
	</p>
	<p class="text-muted text-center text-md-left mb-0 d-none d-md-block">
		 Handcrafted With <i class="mb-1 text-primary ml-1 icon-small" data-feather="heart"></i>
	</p>
</footer>

resources/views/frontend/includes1/menu.blade.php
<ul class="nav">
  <li class="nav-item nav-category">Main</li>
  <li class="nav-item">
    <a href="{{route('frontend.dashboard')}}" class="nav-link">
      <i class="link-icon" data-feather="box"></i>
      <span class="link-title">Dashboard</span>
    </a>
  </li>
  <li class="nav-item">
    <a href="{{route('frontend.map')}}" class="nav-link">
      <i class="link-icon" data-feather="map"></i>
      <span class="link-title">Map</span>
    </a>
  </li>
  <li class="nav-item nav-category">Inovasi</li>
  <li class="nav-item">
    <a href="{{route('frontend.inovasi')}}" class="nav-link">
      <i class="link-icon" data-feather="calendar"></i>
      <span class="link-title">List Inovasi</span>
    </a>
  </li>
</ul>

resources/views/frontend/includes1/nav.blade.php
<nav class="navbar navbar-expand-lg navbar-light bg-light mb-4">
    <a href="{{ route('frontend.index') }}" class="navbar-brand">{{ app_name() }}</a>

    <button class="navbar-toggler navbar-toggler-right" type="button" data-toggle="collapse" data-target="#navbarSupportedContent" aria-controls="navbarSupportedContent" aria-expanded="false" aria-label="@lang('labels.general.toggle_navigation')">
        <span class="navbar-toggler-icon"></span>
    </button>

    <div class="collapse navbar-collapse justify-content-end" id="navbarSupportedContent">
        <ul class="navbar-nav">
            @if(config('locale.status') && count(config('locale.languages')) > 1)
                <li class="nav-item dropdown">
                    <a href="#" class="nav-link dropdown-toggle" id="navbarDropdownLanguageLink" data-toggle="dropdown"
                       aria-haspopup="true" aria-expanded="false">@lang('menus.language-picker.language') ({{ strtoupper(app()->getLocale()) }})</a>

                    @include('includes.partials.lang')
                </li>
            @endif

            @auth
                <li class="nav-item"><a href="{{route('frontend.user.dashboard')}}" class="nav-link {{ active_class(Route::is('frontend.user.dashboard')) }}">@lang('navs.frontend.dashboard')</a></li>
            @endauth

            @guest
                <li class="nav-item"><a href="{{route('frontend.auth.login')}}" class="nav-link {{ active_class(Route::is('frontend.auth.login')) }}">@lang('navs.frontend.login')</a></li>

                @if(config('access.registration'))
                    <li class="nav-item"><a href="{{route('frontend.auth.register')}}" class="nav-link {{ active_class(Route::is('frontend.auth.register')) }}">@lang('navs.frontend.register')</a></li>
                @endif
            @else
                <li class="nav-item dropdown">
                    <a href="#" class="nav-link dropdown-toggle" id="navbarDropdownMenuUser" data-toggle="dropdown"
                       aria-haspopup="true" aria-expanded="false">{{ $logged_in_user->name }}</a>

                    <div class="dropdown-menu" aria-labelledby="navbarDropdownMenuUser">
                        @can('view backend')
                            <a href="{{ route('admin.dashboard') }}" class="dropdown-item">@lang('navs.frontend.user.administration')</a>
                        @endcan

                        <a href="{{ route('frontend.user.account') }}" class="dropdown-item {{ active_class(Route::is('frontend.user.account')) }}">@lang('navs.frontend.user.account')</a>
                        <a href="{{ route('frontend.auth.logout') }}" class="dropdown-item">@lang('navs.general.logout')</a>
                    </div>
                </li>
            @endguest

            <li class="nav-item"><a href="{{route('frontend.contact')}}" class="nav-link {{ active_class(Route::is('frontend.contact')) }}">@lang('navs.frontend.contact')</a></li>
        </ul>
    </div>
</nav>

resources/views/frontend/includes1/topmenu.blade.php
<ul class="navbar-nav">
    <li class="nav-item">
        <a href="{{url('login')}}" class="btn btn-primary btn-icon-text">Login</a>
    </li>
    <li class="nav-item">
        {{-- <a href="{{url('registrasi')}}" class="btn btn-success btn-icon-text">Registrasi</a> --}}
        <button type="button" class="btn btn-success" data-toggle="modal" data-target="#modalRegistrasi">
          Registrasi
      </button>
  </li>
</ul>